/* ConnectionController.h created by ahoesch on Fri 26-Jan-2001 */
#import <AppKit/AppKit.h>
#import <FBEnterprise/FBEnterprise.h>
#import <FBObjects/FBObjects.h>

@class DatabaseController;
@class UserAdaptor;

#define ConnectionControllerActivatedNotification @"ConnectionControllerActivatedNotification"

@interface ConnectionController : NSObject
{
   DatabaseController *_databaseController;
   UserAdaptor *_adaptorController;
   OBModel *_model;
   FBModel *_fbmodel;
   BOOL _connectionEdited;
   BOOL _modelEdited;
}

+ (id)connectionWithDatabaseController:(DatabaseController *)aController;
- (id)initWithDatabaseController:(DatabaseController *)aController;
- (id)initWithDatabaseController:(DatabaseController *)aController forceSystem:(BOOL)flag;

- (Class)adaptorControllerClassForUsername:(NSString *)username;
- (UserAdaptor *)adaptorController;
- (DatabaseController *)databaseController;

- (void)showMainWin;
- (NSWindow *)window;

- (NSString *)name;
- (BOOL)isSystemConnection;
- (void)close;

- (FBDatabaseConnection *)databaseConnection;

- (void)setConnectionEdited:(BOOL)flag;
- (BOOL)isConnectionEdited;
- (void)setModelEdited:(BOOL)flag;
- (BOOL)isModelEdited;
- (BOOL)save;

/* *** database *** */
- (BOOL)readModel;
- (BOOL)writeModel;

- (BOOL)readFromFile:(NSString *)path;

- (OBModel *)model;
- (FBModel *)fbmodel;
- (void)invalidateFBModel;
- (BOOL)downloadModelFromDatabase;

@end
