/* DatabaseController.h created by ahoesch on Fri 14-Apr-2000 */

#import <AppKit/AppKit.h>
#import <FBAccess/FBExecHandler.h>
#import <FBAccess/FBDatabaseConnection.h>
#import "FBItemView.h"

@class ConnectionController;
@class FBDatabaseChannel;

@interface DatabaseController : NSObject < FBItemViewItemProtocol >
{
   NSString *_host;
   NSString *_database;
   NSString *_port;
   NSString *_options;
   FBExecHandler *_exec;
   FBDatabaseStatus _status;
   NSMutableArray *_connectionControllers;
   Class _connectionControllerClass;
   BOOL _stoppingOnPurpose;
}

+ (void)setConnectionControllerClassName:(NSString *)classname;

- (id)initWithHost:(NSString *)aHost database:(NSString *)aDatabase options:(NSString *)aString createIfNotExisting:(BOOL)flag;
- (id)initWithHost:(NSString *)aHost port:(NSString *)aPort options:(NSString *)aString;

- (BOOL)startDatabase;
- (BOOL)startDatabaseAndWait;
- (BOOL)stopDatabase;
- (BOOL)deleteDatabase;
- (void)stoppingOnPurpose;
- (void)databaseStopped;

- (void)newConnectionController;
- (ConnectionController *)newConnectionControllerOfClassNamed:(NSString *)classname;
- (void)removeConnectionController:(ConnectionController *)aController;
- (void)removeAllConnectionControllers;

- (void)updateStatus;

- (NSString *)host;
- (NSString *)database;
- (NSString *)port;
- (FBDatabaseStatus)status;
- (BOOL)isRunning;
- (BOOL)isStopped;

- (void)setOptions:(NSString *)aString;

- (FBExecHandler *)execHandler;
- (ConnectionController *)systemConnection;
- (FBDatabaseChannel *)databaseChannel;

@end
