/* ConnectionController.h created by ahoesch on Fri 26-Jan-2001 */
#import <AppKit/AppKit.h>
#import <FBEnterprise/FBEnterprise.h>
#import <FBObjects/FBObjects.h>

@class FBDatabaseController;
@class FBWindowController;
@class UserAdaptor;

#define ConnectionControllerActivatedNotification @"ConnectionControllerActivatedNotification"

@interface FBConnectionController : NSObject
{
   OBModel *_obmodel;
   FBModel *_fbmodel;
   FBDatabaseController *_databaseController;
   NSMutableArray *_windowControllers;
   UserAdaptor *_adaptorController;
}

/* *** init *** */
+ (id)connectionWithDatabaseController:(FBDatabaseController *)aController;
- (id)initWithDatabaseController:(FBDatabaseController *)aController;
- (id)initWithDatabaseController:(FBDatabaseController *)aController forceSystem:(BOOL)flag;

- (FBDatabaseController *)databaseController;

/* *** windowController *** */
- (void)shutdown;
- (void)addWindowController:(FBWindowController *)windowController;
- (void)removeWindowController:(FBWindowController *)windowController;

/* *** adaptorController *** */
- (Class)adaptorControllerClassForUsername:(NSString *)username;
- (UserAdaptor *)adaptorController;

/* *** model *** */
- (BOOL)readModel;
- (BOOL)writeModel;
- (OBModel *)obmodel;
- (FBModel *)fbmodel;
- (BOOL)readFromFile:(NSString *)path;
- (void)invalidateFBModel;

- (void)showMainWin;
- (BOOL)isSystemConnection;

@end
