/* HostController.h created by ahoesch on Sat 15-Apr-2000 */

#import <AppKit/AppKit.h>
#import <FBAccess/FBExecHandler.h>

@class DatabaseController;

@interface HostController : NSObject
{
   NSString *hostname;
   FBExecHandler *exec;
   NSMutableDictionary *databaseControllerDic; // databaseName --> databaseController
}

+ (void)removePasswordForHost:(NSString *)host;
+ (NSString *)passwordForHost:(NSString *)host;

- (id)initWithHost:(NSString *)aHostname;

- (NSString *)hostname;
- (void)createDatabase:(NSString *)aDatabase withOptions:(NSString *)optionString;
- (void)addMonitoredDatabase:(NSString *)aDatabase withOptions:(NSString *)optionString;
- (void)removeMonitoredDatabase:(NSString *)aDatabase;
- (NSArray *)monitoredDatabases;
- (NSArray *)databaseControllers;

- (NSArray *)allAvailableDatabases;
- (NSArray *)availableDatabases;
- (DatabaseController *)databaseControllerForDatabaseNamed:(NSString *)database;

@end
